



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>nodeJs开发app.js解析</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">nodeJs开发app.js解析</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 00:44:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在 node.js 中模块分为核心模块和文件模块两种，核心模块是通过 require('xxxx') 导入的，文件模块是以 require('/xxxx') 或 require('./xxxx')、require('../xxxx') 形式导入的；核心模块是用c/c++编译的二进制模块，而文件模块是后缀为.js、.json、.node 的文件，在 node.js 中一个文件/文件夹也可以称之为一个模块。更多关于模块及模块加载顺序的信息请查阅官网：<a href="http://zhan.renren.com/login?from=sitePage" rel="external nofollow noreferrer">http://nodejs.org/api/all.html#all_modules</a>&nbsp;<br />这里导入了 express、http、path 核心模块，routes 文件夹下的 index.js 和 user.js 文件模块。</p>
<p>因为 express 框架是依赖 connect 框架（Node的一个中间件框架）创建而成的，可查阅 connect 文档：<a href="http://zhan.renren.com/login?from=sitePage" rel="external nofollow noreferrer">http://www.senchalabs.org/connect/</a>和 express 官方文档：<a href="http://zhan.renren.com/login?from=sitePage" rel="external nofollow noreferrer">http://expressjs.com/api.html</a>了解更多内容。</p>
<p><strong>app.set(name, value)</strong>：设置&nbsp;<code>name</code>&nbsp;的值为&nbsp;<code>value</code></p>
<p><strong>app.set('port', process.env.PORT || 3000)</strong>：设置端口为&nbsp;<code>process.env.PORT</code>&nbsp;或&nbsp;<code>3000</code></p>
<p><strong>app.set('views', __dirname + '/views')</strong>：设置 views 文件夹为视图文件的目录，存放模板文件，__dirname 为全局变量，存储着当前正在执行脚本所在的目录名。</p>
<p><strong>app.set('view engine', 'ejs')</strong>：设置视图模版引擎为 ejs</p>
<p><strong>app.use([path], function)</strong>：使用中间件&nbsp;<code>function</code>，可选参数<code>path</code>默认为"/"</p>
<p><strong>app.use(express.favicon())</strong>：connect 内建的中间件，使用默认的 favicon 图标，如果想使用自己的图标，需改为<code>app.use(express.favicon(__dirname + '/public/images/favicon.ico'));</code>&nbsp;这里我们把自定义的 favicon.ico 放到了 public/images 文件夹下。</p>
<p><strong>app.use(express.logger('dev'))</strong>：connect 内建的中间件，在开发环境下使用，在终端显示简单的不同颜色的日志，比如在启动 app.js 后访问 localhost:3000，终端会输出：</p>
<pre class="prettyprint linenums"><code>Express server listening on port 3000 GET / 200 21ms - 206b GET /stylesheets/style.css 304 4ms </code></pre>
<p>数字200显示为绿色，304显示为蓝色。假如你去掉这一行代码，不管你怎么刷新网页，终端都只有一行 Express server listening on port 3000。</p>
<p><strong>app.use(express.bodyParser())</strong>：connect 内建的中间件，用来解析请求体，支持 application/json， application/x-www-form-urlencoded, 和 multipart/form-data。</p>
<p><strong>app.use(express.methodOverride())</strong>：connect 内建的中间件，可以协助处理 POST 请求，伪装 PUT、DELETE 和其他 HTTP 方法。</p>
<p><strong>app.use(app.router)</strong>：设置应用的路由（可选），详细请参考：<a href="http://zhan.renren.com/login?from=sitePage" rel="external nofollow noreferrer">http://stackoverflow.com/questions/12695591/node-js-express-js-how-does-app-router-work</a></p>
<p><strong>app.use(express.static(path.join(__dirname, 'public')))</strong>：connect 内建的中间件，设置根目录下的 public 文件夹为静态文件服务器，存放 image、css、js 文件于此。</p>
<p><strong>if ('development' == app.get('env')) {app.use(express.errorHandler());}</strong>：开发环境下的错误处理，输出错误信息。</p>
<p><strong>app.get('/', routes.index)</strong>：路由控制器，如果用户访问" / "路径，则由 routes.index 来控制，routes/index.js 内容如下：</p>
<p><code>exports.index = function(req, res){ res.render('index', { title: 'Express' }); };&nbsp;</code></p>
<p>通过 exports.index 导出 index 函数接口，<code>app.get('/', routes.index)</code>&nbsp;相当于：</p>
<p><code>app.get('/', function(req, res){ res.render('index', { title: 'Express' }); };)&nbsp;</code></p>
<p><strong>res.render('index', { title: 'Express' })</strong>：调用 ejs 模板引擎解析 views/index.ejs（我们之前通过&nbsp;<code>app.set('views', __dirname + '/views')</code>设置了模版文件默认存储在 views 下），并传入一个对象作为参数，这个对象只有一个属性 title: 'Express'，即用字符串 Express 替换 views/index.ejs 中所有 title 变量，后面我们将会了解更多关于模板引的内容。</p>
<p><code>http.createServer(app).listen(app.get('port'), function(){ console.log('Express server listening on port ' + app.get('port')); });&nbsp;</code></p>
<p>这段代码的意思是创建服务器并监听3000端口，成功后在命令行中显示 Express server listening on port 3000，然后我们就可以通过在浏览器输入 localhost:3000 来访问了。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93wdngq.html">几个SQL小知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ewerm8.html">unity游戏在logcat中过滤一些不需要的Log</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q70yjj8.html">参数化命令相关知识点之&equals;&equals;&equals;&equals;&equals;&equals;&equals;&equals;&equals;&equals;&equals;&equals;&equals;&equals;&equals;&equals;&equals;&equals;防止SQl的注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gr74eq.html">&lpar;原&rpar; 1&period;1  Zookeeper单机安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ooy058.html">编译hadoop-2&period;5&period;2总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e65oeq.html">git 创建本地分支，然后推送到服务器上</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9prymdq.html">Error occurred during initialization of VM java&sol;lang&sol;NoClassDefFoundError&colon; java&sol;lang&sol;Object</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qypdydq.html">linux useradd&lpar;adduser&rpar;命令参数及用法详解&lpar;linux创建新用户命令&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ep3jj9.html">myeclipse 8&period;5 常用快捷键【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnm0o0q.html">linux 内核手动编译</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xm1vv8.html">android adb服务启动不了解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm5z5x9.html">Delphi XE5教程12：注释和编译器指示字</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m221kq.html">OC3&lowbar;歌词解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey1p2e9.html">用C&plus;&plus;语言开发Android程序 配置开发环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpknxvq.html">&period;net core 2&period;0学习笔记（三）：度量&period;net framework 迁移到&period;net core的工作量</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy102jdq.html">Oracle12C如何启动PDB数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo202xq.html">创建和注册自定义 HTTP 模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rzpr48.html">执行monkey APK 制作</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5d6xrq.html">1130-Host &amp;&num;39&semi;192&period;168&period;0&period;105&amp;&num;39&semi; is not allowed to connect to this MySQL server的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2ldz2q.html">Hibernate的入门&lpar;概念1&rpar;&colon;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/495ezov9.html">客户端连接linux经常间隔性断开链接</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8egr5e9.html">Blob&lpar;二进制&rpar;、byte&lbrack;&rsqb;、long、date之间的类型转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o6l218.html">C&num; 命令绑定</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwgzmk8.html">Pig Latin</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jox3wq.html">javascript动态添加本地文件列表信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4owd38.html">&lpar;转&rpar;ajax&period;dll&comma;ajaxpro&period;dll的区别和用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnxk4g9.html">jquery星级评论打分组件</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r2p5rq.html">Modifier</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ke62r8.html">js获取文件大小</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p45149.html">【Java学习笔记】&amp;lt&semi;集合框架&amp;gt&semi;定义功能去除ArrayList中的重复元素</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
